#! /bin/bash

# Aileunの最新モデル番号
AILEUN_LAST_MODEL_NUMBER=6
# Aileunの一番古いモデル番号
AILEUN_OLDEST_MODEL_NUMBER=1

TMP_DIR=/tmp
AILE_DIR=/opt/aile
AILEUN_DIR=$TMP_DIR/aileun_6
WORK_DIR=$AILEUN_DIR/config
COMPRESS_FILE=$TMP_DIR/aileun_6.zip
AILE_CONFIG_DIR=$AILE_DIR/config
AILE_CONFIG_BAK_DIR=$TMP_DIR/config_bak
AILE_UI_DIR=$AILE_DIR/ui
DONT_REMOVE_FILE_LIST=$AILE_DIR/dont_remove.list

### 削除対象外のconfig以外を除
if [ ! -e $AILE_CONFIG_BAK_DIR ]; then
	mkdir $AILE_CONFIG_BAK_DIR
fi

# 対象外のリストから一致するconfigを一時的に移動
for confFile in `cat $DONT_REMOVE_FILE_LIST`
do
	if [ -e $AILE_CONFIG_DIR/$confFile ]; then
		sudo mv $AILE_CONFIG_DIR/$confFile $AILE_CONFIG_BAK_DIR/$confFile
	fi
done
# config以下削除
sudo rm $AILE_CONFIG_DIR/*
# 一時的に移動したconfigを元に戻す
sudo mv $AILE_CONFIG_BAK_DIR/* $AILE_CONFIG_DIR/

if [ -e $AILE_CONFIG_BAK_DIR ]; then
	sudo rm -fr $AILE_CONFIG_BAK_DIR/
fi

### アップロードしたconfigを展開
cd $TMP_DIR
unzip $COMPRESS_FILE > /dev/null

# 最新のモデルから設定ファイルのディレクトリを検索
# 見つからなければ下位モデルのディレクトリを検索していく
for no in `seq $AILEUN_LAST_MODEL_NUMBER -1 $AILEUN_OLDEST_MODEL_NUMBER`
do
	AILEUN_DIR=`printf "%s/aileun_%d" $TMP_DIR $no`
	WORK_DIR=`printf "%s/config" $AILEUN_DIR`
	if [ -e $WORK_DIR ]; then
		break
	fi
done

sudo chown aile:aile $WORK_DIR/* 

sudo mv $WORK_DIR/* $AILE_CONFIG_DIR/

if [ -e $AILE_CONFIG_DIR/gtkrc.conf ]; then
	sudo cp -f $AILE_CONFIG_DIR/gtkrc.conf $AILE_UI_DIR/gtkrc
fi

# netplan.confの移動
if [ -e $AILE_CONFIG_DIR/netplan.conf ]; then
	mv $AILE_CONFIG_DIR/netplan.conf $AILE_DIR/netplan.conf
fi

sudo rm -fr $COMPRESS_FILE $AILEUN_DIR
