#!/bin/bash
#######################################################
# ミラーリング
#######################################################

. /opt/aile/aile_common.sh

OUTPUT_ACTIVE_DISPLAYS=()
# 先に接続されたモニターが音声優先される
AUDIO_OUTPUT=`/opt/aile/get_audio_output.sh`
if [ "$AUDIO_OUTPUT" = "DP" ]; then
	OUTPUT_ACTIVE_DISPLAYS=(`xrandr | grep " connect" | cut -d " " -f1 | sort -r`)
else
	OUTPUT_ACTIVE_DISPLAYS=(`xrandr | grep " connect" | cut -d " " -f1`)
fi

for display in `xrandr | grep " disconnect" | cut -d " " -f1`
do
	xrandr --output $display --off
done

for output_active_display in "${OUTPUT_ACTIVE_DISPLAYS[@]}";
do
	xrandr --output $output_active_display --auto
	# モニターによってデフォルト解像度が変わるので、先頭の解像度をデフォルト(仮)に設定
	tmp_default_mode=`/opt/aile/monitor-utility $output_active_display 1`
	if [ "$tmp_default_mode" != "" ]; then
		xrandr --output $output_active_display --mode $tmp_default_mode
	fi
done
